#include <pthread.h>

typedef struct {
  pthread_mutex_t *fst_mutex, *lst_mutex ;
  pthread_cond_t *is_empty, *is_full ;

  int sz ;
  int fst,lst,nitems ;
  void **t ;
} fifo_t ;

fifo_t *alloc_fifo(int sz) ;
void free_fifo(fifo_t *f) ;

void put(fifo_t *f,void *z) ;
void *get(fifo_t *f) ;
